/*
 * The MIT License (MIT)
 *
 * Copyright (c) 2015 Microsoft Corporation
 * 
 * -=- Robust Distributed System Nucleus (rDSN) -=- 
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

/*
 * Description:
 *     What is this file about?
 *
 * Revision history:
 *     xxxx-xx-xx, author, first version
 *     xxxx-xx-xx, author, fix bug about xxx
 */


# include "hpc_env_provider.h"

# ifdef __TITLE__
# undef __TITLE__
# endif
# define __TITLE__ "env.provider.hpc"

namespace dsn
{
    namespace tools
    {
        hpc_env_provider::hpc_env_provider(env_provider* inner_provider)
            : env_provider(inner_provider)
        {
            _ns_start = utils::get_current_physical_time_ns();
# if defined(_WIN32)
            ::QueryPerformanceCounter((LARGE_INTEGER*)&_tick_start);

            uint64_t freq;
            ::QueryPerformanceFrequency((LARGE_INTEGER*)&freq);
            _tick_frequency_per_ns = (double)freq / 1000.0 / 1000.0 / 1000.0;
# else
            // TODO:
# endif
        }
    }
}
